=== Presets/presets/CMakeLists.txt ===
INSTALL(
    FILES
        "abra-kadabra.sh"
        "cool-jives.sh"
        "crooked-nose.sh"
        "fools-gold.sh"
        "hello-world.sh"
        "john_galt_line-500.sh"
        "rin-tin-tin.sh"
        "yellow-brick-road.sh"
    DESTINATION
        "${PKGDATADIR}/presets"
)
