## freecell-solver 2.8.6-1

=== debian/changelog ===
freecell-solver (2.8.6-1) unstable; urgency=low

  * New upstream release
    - added new config.guess, sub and friends (closes: #177573)

 -- RISKO Gergely <risko@debian.org>  Fri, 21 Mar 2003 08:00:52 +0100

freecell-solver (2.8.3-2) unstable; urgency=low

  * regenerated configure and friends with new libtool (closes: #177189)

 -- RISKO Gergely <risko@debian.org>  Sat, 18 Jan 2003 16:57:27 +0100

freecell-solver (2.8.3-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Fri, 17 Jan 2003 14:45:59 +0100

freecell-solver (2.8.2-1) unstable; urgency=low

  * New upstream version
  * now using more upstream man pages

 -- RISKO Gergely <risko@debian.org>  Sun, 10 Nov 2002 18:09:28 +0100

freecell-solver (2.8.0-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Wed,  2 Oct 2002 16:38:40 +0200

freecell-solver (2.6.3-1) unstable; urgency=low

  * new upstream release

 -- RISKO Gergely <risko@debian.org>  Thu, 29 Aug 2002 19:13:53 +0200

freecell-solver (2.6.2-1) unstable; urgency=low

  * new upstream release 

 -- RISKO Gergely <risko@debian.org>  Thu, 25 Jul 2002 17:12:37 +0200

freecell-solver (2.6.0-1) unstable; urgency=low

  * new upstream release
  * wow, it's not native now, I hope it won't be native again...

 -- RISKO Gergely <risko@debian.org>  Tue, 16 Jul 2002 17:37:29 +0200

freecell-solver (2.4.2.1) unstable; urgency=low

  * new upstream release
  * since now this is a native debian package

 -- RISKO Gergely <risko@debian.org>  Tue,  2 Jul 2002 14:33:01 +0200

freecell-solver (2.4.1-1) unstable; urgency=low

  * new upstream version.

 -- RISKO Gergely <risko@debian.org>  Sat,  6 Apr 2002 11:35:18 +0200

freecell-solver (2.2.2-1) unstable; urgency=low

  * New upstream version.

 -- RISKO Gergely <risko@debian.org>  Sat, 23 Feb 2002 19:26:54 +0100

freecell-solver (2.0.0-2) unstable; urgency=low

  * copyright file fix (closes: Bug#126593) 

 -- RISKO Gergely <risko@debian.org>  Thu, 27 Dec 2001 12:26:39 +0100

freecell-solver (2.0.0-1) unstable; urgency=low

  * The package is now lintian clean.
  * New upstream version.

 -- RISKO Gergely <risko@debian.org>  Mon, 24 Dec 2001 10:59:04 +0100

freecell-solver (1.10.1-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Wed, 21 Dec 2001 18:51:23 +0100

freecell-solver (1.8.2-1) unstable; urgency=low

  * New upstream release
  * Everything except freecell-solver-bin is lintian clean

 --  <yotam@makif.omer.k12.il>  Sat, 22 Sep 2001 16:56:40 +0300

freecell-solver (1.6.7-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Mon, 11 Jun 2001 02:51:44 +0300

freecell-solver (1.6.6-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Thu, 31 May 2001 23:27:56 +0300

freecell-solver (1.6.5-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Sun, 27 May 2001 02:10:08 +0300

freecell-solver (1.6.4-1) unstable; urgency=low

  * First Debian release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Wed, 23 May 2001 22:53:00 +0300

 
