=== debian/control ===
Source: freecell-solver
Section: devel
Priority: optional
Maintainer: RISKO Gergely <risko@debian.org>
Standards-Version: 3.5.6
Build-depends: automake, libtool

Package: libfreecell-solver0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.

Package: libfreecell-solver-dev
Architecture: any
Depends: libfreecell-solver0 (>= 2.0.0)
Description: Library for solving Freecell games (Development files)
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the files necessary to produce binaries which are
 linked against libfreecell-solver.
 
Package: freecell-solver-bin
Architecture: any
Section: games
Depends: ${shlibs:Depends}, python | python-base
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the binaries included with freecell-solver
