=== Presets/presets/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,12 @@
         "cool-jives.sh"
         "crooked-nose.sh"
         "fools-gold.sh"
+        "gooey-unknown-thing.sh"
         "hello-world.sh"
         "john_galt_line-500.sh"
         "rin-tin-tin.sh"
+        "sand-stone.sh"
+        "toons-for-twenty-somethings.sh"
         "yellow-brick-road.sh"
     DESTINATION
         "${PKGDATADIR}/presets"
