## freecell-solver 3.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
 INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )
+
+LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # This is the equivalent to perform a "make dist"/"make distdir" etc.
 SET(CPACK_PACKAGE_NAME "freecell-solver")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Freecell Solver")
 SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
-SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
+SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
+SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
 
 # Process and extract the version number.
 FILE( READ "ver.txt" VERSION)
@@ -21,19 +23,23 @@
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
 SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+
+SET (base_with_ver "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")
 
 SET(CPACK_SOURCE_IGNORE_FILES
     "/_CPack_Packages/"
     "/CMakeFiles/"
     "/.deps/"
-    "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+(-Source|-Linux|)(/|\\\\.(sh|tar\\\\.(gz|bz2|Z|lzma|xz))$)"
+    "^${base_with_ver}(-Source|-Linux)?/"
+    "${base_with_ver}.tar\\\\.(gz|bz2|Z|lzma|xz)$"
     "\\\\.o$"
     "~$"
     "/board_gen/(pi-make-microsoft-freecell-board|make-microsoft-freecell-board|make-gnome-freecell-board|make-aisleriot-freecell-board)$"
-    "/(fc-solve|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve)$"
+    "/(fc-solve|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve|freecell-solver-fork-solve|measure-depth-dep-tests-order-perf)$"
     "/lib(fcs|freecell-solver)\\\\.(a|la)$"
     "\\\\.so(\\\\.[0-9]+)*$"
     "/\\\\.svn/"
+    "\\\\.(pdf|fo)$"
     "/t/t/.*\\\\.exe$"
     "/t/Presets"
     "/CMakeCache\\\\.txt$"
@@ -79,7 +85,7 @@
 
 ### This is to set the RPATH correctly, so when installed under a prefix
 ### the executables will find the libraries.
-### 
+###
 ### See:
 ###
 ### http://www.cmake.org/Wiki/CMake_RPATH_handling
@@ -91,41 +97,59 @@
 
 # when building, don't use the install RPATH already
 # (but later on when installing)
-SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
 # the RPATH to be used when installing
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
 
 # add the automatically determined parts of the RPATH
 # which point to directories outside the build tree to the install RPATH
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 
 
-SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING 
+SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING
     "States Type ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES'). No need to usually change.")
+SET (FCS_ENABLE_RCS_STATES CACHE BOOL "Whether to use RCS-like states (requires a STATES_TYPE of COMPACT_STATES")
 SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
+SET (FCS_IA_PACK_SIZE 64 CACHE STRING "Size of a single pack in kilo-bytes.")
 SET (MAX_NUM_FREECELLS 8 CACHE STRING "Maximal Number of Freecells")
 SET (MAX_NUM_STACKS 10 CACHE STRING "Maximal Number of Stacks")
 SET (MAX_NUM_INITIAL_CARDS_IN_A_STACK 8 CACHE STRING
     "Maximal Number of Initial Cards in a Stack")
 SET (MAX_NUM_DECKS 2 CACHE STRING "Maximal Number of Decks (1 or 2)")
+SET (MAX_NUM_BENCHMARK_THREADS 4 CACHE STRING "Maximal Number of Threads to Use When Benchmarking")
 
 SET (FCS_STATE_STORAGE "FCS_STATE_STORAGE_INTERNAL_HASH" CACHE STRING "The State Storage Type")
 SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_INTERNAL_HASH" CACHE STRING "The Stack Storage Type")
 
+SET (FCS_WHICH_COLUMNS_GOOGLE_HASH "FCS_WHICH_COLUMNS_GOOGLE_HASH__SPARSE" CACHE STRING "The Columns' Google Hash Type")
+SET (FCS_WHICH_STATES_GOOGLE_HASH "FCS_WHICH_STATES_GOOGLE_HASH__SPARSE" CACHE STRING "The States/Positions' Google Hash Type")
+
 SET (FCS_FREECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell (not recommended)")
 SET (FCS_DISABLE_SIMPLE_SIMON "" CACHE BOOL "Exclude being able to solve Simple Simon from the Binary (not recommended)")
-SET (FCS_WITHOUT_CARD_FLIPPING "" CACHE BOOL "Exclude the flipping of cards from the binary.")
+SET (FCS_WITHOUT_CARD_FLIPPING "1" CACHE BOOL "Exclude the flipping of cards from the binary.")
 SET (FCS_WITH_TEST_SUITE "" CACHE BOOL "Also build and run the test suite.")
-
-SET (FCS_ENABLE_SECONDARY_HASH_VALUE "" 
-    CACHE BOOL 
+SET (FCS_LINK_TO_STATIC "" CACHE BOOL "Link to the static library.")
+SET (FCS_HARD_CODED_NUM_FCS_FOR_FREECELL_ONLY "4" CACHE STRING "The hard-coded number of freecells (4, 2, etc.). Usually ignored")
+
+SET (FCS_ENABLE_SECONDARY_HASH_VALUE ""
+    CACHE BOOL
     "Enable the secondary hash value calculation and track-keeping. Seems to slow things down."
 )
 
-SET (FCS_WITH_CONTEXT_VARIABLE "1" 
-    CACHE BOOL 
+SET (FCS_WITH_CONTEXT_VARIABLE "1"
+    CACHE BOOL
     "Enable the context (extra void *) as passed to the comparison functions, etc."
+)
+
+SET (FCS_INLINED_HASH_COMPARISON "1"
+    CACHE BOOL
+    "Use more compact tokens for moves internally (makes things slower)"
+)
+
+SET (FCS_AVOID_TCMALLOC ""
+    CACHE BOOL
+    "Avoid linking against Google's tcmalloc"
 )
 
 SET (BUILD_STATIC_LIBRARY "1" CACHE BOOL "Whether to build the static library (which takes more time)" )
@@ -137,11 +161,19 @@
 SET (FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the stack storage. Ignored if not set to libavl2")
 SET (LIBAVL2_SOURCE_DIR "/usr/src/avl-2.0.3" CACHE STRING "The location of the libavl2 source tree (from which files are copied)")
 
+SET (FCS_WITHOUT_VISITED_ITER "" CACHE BOOL "Disable the visited_iter counter in each state (somewhat useful for debugging, otherwise not needed.)")
+SET (FCS_WITHOUT_DEPTH_FIELD "" CACHE BOOL "Disable the depth field in each state (not absolutely necessary.)")
+SET (FCS_WITHOUT_LOCS_FIELDS "" CACHE BOOL "Disable the columns and freecells permutations fields in each state (they are not absolutely necessary.)")
+
 IF (NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
     MESSAGE(FATAL_ERROR "STATES_TYPE should be ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES')")
 ENDIF(NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
 
 SET (${STATES_TYPE} 1)
+
+IF (FCS_ENABLE_RCS_STATES)
+    SET (FCS_RCS_STATES 1)
+ENDIF (FCS_ENABLE_RCS_STATES)
 
 SET (FREECELL_SOLVER_LIB_MODULES alloc.c app_str.c card.c check_and_add_state.c cmd_line.c freecell.c instance.c lib.c move.c move_funcs_maps.c move_funcs_order.c preset.c scans.c simpsim.c split_cmd_line.c state.c)
 
@@ -154,8 +186,13 @@
     LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES simpsim.c)
 ENDIF (FCS_DISABLE_SIMPLE_SIMON)
 
+IF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))
+    # FCS_STACK_STORAGE in this case is irrelevant and should be ignored.
+    SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_NULL")
+ENDIF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))
+
 # Add the fcs_hash.c if (and only if) it is being used.
-# 
+#
 IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
     (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))
 
@@ -164,8 +201,19 @@
 ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
     (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))
 
+
+# Add the google_hash.cpp if (and only if) it is being used.
+#
+IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))
+
+    LIST(APPEND FREECELL_SOLVER_LIB_MODULES google_hash.cpp)
+
+ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))
+
 # Add fcs_dm.c if (and only if) it is being used.
-# 
+#
 IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
     LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_dm.c)
 ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
@@ -181,12 +229,14 @@
 
 # Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
 IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
+    FCS_RCS_STATES)
 
     FIND_LIBRARY(LIBJUDY_LIB Judy)
 
 ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-       (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))
+(${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
+    FCS_RCS_STATES)
 
 SET (LIBAVL2_COPIED_MODULES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libavl2")
 
@@ -225,83 +275,5 @@
 
 IF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")
     SET (TREE_TYPE "${FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE}")
-    ADD_TREE_TYPE("${TREE_TYPE}")    
+    ADD_TREE_TYPE("${TREE_TYPE}")
     FILE (MAKE_DIRECTORY "${LIBAVL2_COPIED_MODULES_DIR}")
-    SET (MPROT "FC_SOLVE__STACK_STORAGE_H")
-    SET (PREFIXO "fcs_libavl2_stacks_tree")
-    FILE (WRITE "${LIBAVL2_COPIED_MODULES_DIR}/fcs_libavl2_stack_storage.h"
-"
-#ifndef ${MPROT}
-#define ${MPROT}
-
-#include \"${TREE_TYPE}.h\"
-
-typedef struct ${TREE_TYPE}_table ${PREFIXO}_table_t;
-#define ${PREFIXO}_insert(a,b) ${TREE_TYPE}_insert((a),(b))
-#define ${PREFIXO}_create(a,b,c) ${TREE_TYPE}_create((a),(b),(c))
-#define ${PREFIXO}_destroy(a,b) ${TREE_TYPE}_destroy((a),(b))
-
-#endif /* ${MPROT} */
-"
-    )
-
-ENDIF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")
-
-IF (LIBAVL2_TREE_TYPES)
-    INCLUDE_DIRECTORIES(BEFORE "${LIBAVL2_COPIED_MODULES_DIR}")
-    FOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
-        SET (C_FN "${TREE_TYPE}.c")
-        SET (H_FN "${TREE_TYPE}.h")
-        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${C_FN}" 
-            "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}"
-            COPYONLY
-        )
-        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${H_FN}" 
-            "${LIBAVL2_COPIED_MODULES_DIR}/${H_FN}"
-            COPYONLY
-        )
-        LIST(APPEND FREECELL_SOLVER_LIB_MODULES "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}")
-    ENDFOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
-ENDIF (LIBAVL2_TREE_TYPES)
-
-SET (MY_LINK_FLAGS "")
-SET (MY_TO_PROFILE "")
-IF (CMAKE_BUILD_TYPE STREQUAL profile)
-    SET (MY_TO_PROFILE "1")
-    SET (CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_DEBUG} -pg")
-    SET (MY_LINK_FLAGS "-pg -static-libgcc")
-    SET (BUILD_STATIC_LIBRARY "1")
-    SET (MY_TARGET_LINK_LIBS "freecell-solver-static" "m_p" "c_p")
-ELSE (CMAKE_BUILD_TYPE STREQUAL profile)
-    SET (MY_TARGET_LINK_LIBS "freecell-solver")
-ENDIF (CMAKE_BUILD_TYPE STREQUAL profile)
-
-INCLUDE(CPack)
-
-include(CheckFunctionExists)
-INCLUDE(CheckCCompilerFlag)
-INCLUDE(FindThreads)
-
-ADD_SUBDIRECTORY ("board_gen")
-ADD_SUBDIRECTORY ("man")
-ADD_SUBDIRECTORY ("Presets")
-ADD_SUBDIRECTORY ("t")
-
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
-
-SET(COMPILER_FLAGS_TO_CHECK 
-    "-Wall" "-Werror=implicit-function-declaration" "-fvisibility=hidden"
-)
-
-IF (CPU_ARCH)
-    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-march=${CPU_ARCH}")
-ENDIF(CPU_ARCH)
-
-IF (OPTIMIZATION_OMIT_FRAME_POINTER)
-    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-fomit-frame-pointer")
-ENDIF(OPTIMIZATION_OMIT_FRAME_POINTER)
-
-SET (IDX 1)
-FOREACH (CFLAG_TO_CHECK ${COMPILER_FLAGS_TO_CHECK})
-    SET (FLAG_EXISTS_VAR "FLAG_EXISTS_${IDX}")
-    MATH (EXPR IDX "${IDX} + 1")
